import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

/// try catch function
tryCatch(
  BuildContext context, {
  Function action,
  Function formatException(error, stackTrace),
  Function platformException(error, stackTrace),
  Function exception(error, stackTrace),
  Function error(error, stackTrace),
  Function otherCatch(error, stackTrace),
}) async {
  try {
    action();
  } on FormatException catch (e, s) {
    formatException(e, s);
  } on PlatformException catch (e, s) {
    platformException(e, s);
  } on Exception catch (e, s) {
    exception(e, s);
  } on Error catch (e, s) {
    error(e, s);
  } catch (e, s) {
    otherCatch(e, s);
  }
}
